import { LoadingProps, LOADING_MODE } from './types';
import AIcon from 'ant-design-vue/es/icon';
import './style.less';
export default {
  name: 'ELoading',
  props: LoadingProps,
  computed: {
    modeMap: function modeMap() {
      return LOADING_MODE[this.mode];
    },
    modeIcon: function modeIcon() {
      if (this.modeMap) {
        return this.modeMap.icon;
      }

      return 'loading';
    },
    modeText: function modeText() {
      if (this.text) {
        return this.text;
      }

      if (this.modeMap) {
        return this.modeMap.text;
      }

      return '加载中...';
    }
  },
  render: function render() {
    var h = arguments[0];
    var iconColor = {
      color: this.$props.color
    };
    var spanClass = "loading-text ".concat(this.$props.mode);
    return h("div", {
      "class": "flex-v flex-hc flex-vc loading-component-wrapper"
    }, [h(AIcon, {
      attrs: {
        type: this.modeIcon
      },
      "class": "loading-icon",
      style: iconColor
    }), h("span", {
      "class": spanClass
    }, [this.modeText])]);
  }
};