"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _isPromise = _interopRequireDefault(require("is-promise"));

var _modal = _interopRequireDefault(require("ant-design-vue/es/modal"));

var _propsUtil = require("ant-design-vue/es/_util/props-util");

var _button = _interopRequireDefault(require("ant-design-vue/es/button"));

var _types = require("./types");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/**
 *  模态弹框，内部处理confirmLoading
 */
var _default = {
  name: 'EModal',
  "extends": _modal["default"],
  props: _types.ModalProps,
  data: function data() {
    return {
      easyConfirmLoading: false
    };
  },
  methods: {
    handleOk: function handleOk(e) {
      var _this = this;

      // 判断props中是否传入了okFunc，是则调用此方法
      if (this.$props.okFunc) {
        var res = this.$props.okFunc(e);

        if ((0, _isPromise["default"])(res)) {
          this.$data.easyConfirmLoading = true;
          res.then(function () {
            _this.$data.easyConfirmLoading = false; // 成功返回自动隐藏弹框

            _this.$emit('change', false);
          })["catch"](function () {
            _this.$data.easyConfirmLoading = false;
          });
        }
      } else {
        this.$emit('ok', e);
      }
    },
    renderFooter: function renderFooter(locale) {
      var h = this.$createElement;
      var okType = this.okType;
      var confirmLoading = this.easyConfirmLoading;
      var cancelBtnProps = (0, _propsUtil.mergeProps)({
        on: {
          click: this.handleCancel
        }
      }, this.cancelButtonProps || {});
      var okBtnProps = (0, _propsUtil.mergeProps)({
        on: {
          click: this.handleOk
        },
        props: {
          type: okType,
          loading: confirmLoading
        }
      }, this.okButtonProps || {});
      return h('div', [h(_button["default"], cancelBtnProps, [(0, _propsUtil.getComponentFromProp)(this, 'cancelText') || locale.cancelText]), h(_button["default"], okBtnProps, [(0, _propsUtil.getComponentFromProp)(this, 'okText') || locale.okText])]);
    }
  }
};
exports["default"] = _default;