"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _Loading = _interopRequireDefault(require("../Loading"));

var _card = _interopRequireDefault(require("ant-design-vue/es/card"));

var _steps = _interopRequireDefault(require("ant-design-vue/es/steps"));

require("./style.less");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var AStep = _steps["default"].Step;
/**
 * 分步表单的页面,分步页面需要继承。如添加商户的页面，MerchantAdd需要从这个继承
 */

var _default = {
  name: 'EBaseStepPage',
  props: {},
  data: function data() {
    return {
      // 是否是新增
      isAdd: true,
      // 当前的步骤进度，0开始-6结束
      currentTab: 0,
      // 已展示的组件index列表
      showedList: [],
      // step的上下文数据,获取详情的数据,用于展示
      stepData: {},
      // 展示loading
      showLoading: false,
      // 提交商户信息的时候的保存按钮的loading
      saveLoading: false,
      // 保存草稿的loading
      // draftLoading: false,
      // 结果ui组件的名称，如有需要继承
      resultComponentName: 'result-com',
      // 最后一个填写步骤的编号，需继承
      totalStepNum: 0,
      // step文字列表，需继承
      stepTextList: [],
      // 步骤组件列表，除完成以外的，需继承
      stepList: [],
      // 保存到协议，需修改
      saveMethod: null,
      // 是否有保存草稿到功能，如有需要继承
      // showDraft: false,
      // 是否只更新图片
      isOnlyUpdatePhoto: false // 失败原因
      // reason: '',
      // 从第几个index开始展示图片，自行判断初始化oss
      // showPhotoIndex: 0,
      // id取值的key
      // idName: ''

    };
  },
  computed: {
    // 页面pageHeader标题，需继承
    // pageTitle() {
    //   return ''
    // },
    // // 页面pageHeader副标题，需继承
    // pageSubTitle() {
    //   return ''
    // },
    // // 页面pageHeader描述，需继承
    // pageDesc() {
    //   return ''
    // },
    // 展示结果
    showResult: function showResult() {
      return this.currentTab === this.totalStepNum + 1;
    }
  },
  watch: {
    currentTab: function currentTab(newVal) {
      // 每次当前展示改变后将此index存入showedList
      this._addToShowedList(newVal);
    }
  },
  created: function created() {
    this._initPage(this.context);
  },
  mounted: function mounted() {},
  methods: {
    /**
     * 初始化页面
     * @private
     */
    _initPage: function _initPage(context) {
      var _this = this;

      if (context) {
        this.isAdd = false;
        this.showLoading = true;
        this.stepData = context;

        this._getInfo().then(function (res) {
          _this.stepData = res;
          _this.showLoading = false;

          _this._addToShowedList(_this.currentTab);
        })["catch"](function () {});
      } else {
        this.isAdd = true; // this.reason = ''

        this.showLoading = false; // this.showDraft = true

        this._addToShowedList(this.currentTab);
      }
    },
    // 表单值变动
    _formValueChange: function _formValueChange(key, value) {
      this.$set(this.stepData, key, value);
    },

    /**
     * 添加到已展示的列表中
     * @private
     */
    _addToShowedList: function _addToShowedList(index) {
      if (!this.showedList.includes(index)) {
        this.showedList.push(index);

        this._notifyStepShow(index, true); // this._initOss(this.stepData[this.idName])

      } else {
        this._notifyStepShow(index, false);
      }
    },

    /**
     * 通知对应step目前show
     * @param index 当前展示的step顺序
     * @param isFirst 是否是第一次展示
     * @private
     */
    _notifyStepShow: function _notifyStepShow(index, isFirst) {
      var _this2 = this;

      // 判断当前展示的step是否有show方法，有的话调用
      this.$nextTick(function () {
        if (_this2.$refs.addStep) {
          var currentStep = _this2.$refs.addStep[index];

          if (currentStep && currentStep.show) {
            currentStep.show(isFirst);
          }
        }
      });
    },

    /**
     * 获取已展示的所有表单的数据
     * @returns {{}}
     */
    getAllFormData: function getAllFormData() {
      var allForm = {}; // console.info('this.$refs', Object.keys(this.$refs))

      for (var item in this.$refs) {
        // console.info('item', item)
        if (item.startsWith('addStep')) {
          var addStepCom = this.$refs[item];
          var stepForm = addStepCom.getFormData(); // console.log(`~~~${index}~~~`, stepForm)

          allForm = _extends({}, allForm, stepForm);
        }
      } // eslint-disable-next-line no-unused-vars
      // this.$refs.forEach((stepDom, index) => {
      //   console.info('stepDom', stepDom)
      //   const stepForm = stepDom.getFormData()
      //   // console.log(`~~~${index}~~~`, stepForm)
      //   allForm = Object.assign({}, allForm, stepForm)
      // })


      return allForm; // return Object.assign({}, this.stepData, allForm)
    },
    // /**
    //  * 保存草稿
    //  * @private
    //  */
    // _saveDraft() {
    //   // const allForm = Object.assign({}, this.stepData, this._getAllFormData())
    //   const allForm = this._getAllFormData()
    //   const draftForm = this._parseSubmitData(allForm)
    //   // 保存草稿最起码需要填写商户名称
    //   const result = this._draftValid(draftForm)
    //   if (isPromise(result)) {
    //     result
    //       .then(() => {
    //         this._draftValidateToSave(draftForm)
    //       })
    //       .catch(() => {
    //         this.draftLoading = false
    //       })
    //   } else {
    //     if (result) {
    //       this._draftValidateToSave(draftForm)
    //     }
    //   }
    // },
    // /**
    //  * 草稿校验通过，保存
    //  */
    // async _draftValidateToSave(draftForm) {
    //   this.draftLoading = true
    //   try {
    //     const id = await this._draftPost(draftForm)
    //     // this.draftLoading = false
    //     // 保存草稿成功后返回也需要刷新列表
    //     this.backNeedRefresh = true
    //     this.$message.success('保存草稿成功')
    //     this.stepData = await this._getStepData(id)
    //     if (this.isAdd) {
    //       // 如果是新增的话，保存草稿后有了id，需要重新初始化oss
    //       // 现在是编辑了
    //       this.isAdd = false
    //       this._initOss(id)
    //     }
    //     // eslint-disable-next-line no-empty
    //   } catch (e) {
    //   } finally {
    //     this.draftLoading = false
    //   }
    // },

    /**
     * 上一步,要求保存表单数据
     * @private
     */
    // eslint-disable-next-line no-unused-vars
    _previewStep: function _previewStep(form) {
      if (this.currentTab > 0) {
        this.currentTab--;
      }
    },

    /**
     * 下一步
     * @private
     */
    _nextStep: function _nextStep() {
      var _this3 = this;

      if (this.currentTab < this.totalStepNum) {
        this.currentTab++;
      } else if (this.currentTab === this.totalStepNum) {
        // 倒数第二步发送保存协议，保存成功后展示成功结果
        this.saveLoading = true;
        var allForm = this.getAllFormData(); // 判断是否只更新图片，目前图片拒绝也能更新其他数据
        // const saveData = this.isOnlyUpdatePhoto
        //   ? this._parseSubmitPhotoData(allForm) : this._parseSubmitData(allForm)

        var saveData = this._parseSubmitData(allForm);

        console.log('~~~saveData~~~', saveData);
        this.saveMethod(saveData) // eslint-disable-next-line no-unused-vars
        .then(function (res) {
          _this3.saveLoading = false;
          _this3.currentTab = _this3.totalStepNum + 1; // 需要更新商户id
          // this.stepData = Object.assign({}, this.stepData, res || {})
          // 如果当前当前商户没有id则更新id
          // if (!saveData[this.idName]) {
          //   saveData[this.idName] = res[this.idName]
          // }

          _this3.stepData = saveData; // 提交协议成功后点击返回是需要刷新列表的

          _this3.backNeedRefresh = true;
        })["catch"](function (error) {
          console.log('~~~提交错误~~~', error.message);
          _this3.saveLoading = false;
        });
      }
    },

    /**
     * 重置到空
     * @private
     */
    _resetToEmpty: function _resetToEmpty() {
      var _this4 = this;

      // 新增
      this.showLoading = true;
      this.currentTab = 0;
      this.stepData = {};
      this.showedList = [];
      this.isOnlyUpdatePhoto = false; // this.reason = ''
      // this.saveMethod = this.$payApi.merchant_register_post

      this.$nextTick(function () {
        _this4._initPage();
      });
    },

    /**
     * 返回
     * @private
     */
    _goBack: function _goBack() {// this._handleBackToRefresh()
    },

    /**
     * 获取页面详情数据（可能有多个协议，还有一些特殊处理），需继承
     * @private
     */
    _getInfo: function _getInfo() {
      return Promise.resolve();
    },
    // /**
    //  * 获取详情协议，需继承
    //  * @private
    //  */
    // // eslint-disable-next-line no-unused-vars
    // _getStepData(id) {
    //   return Promise.resolve({})
    // },
    // /**
    //  * 草稿表单的校验，如有需要继承
    //  * @private
    //  */
    // // eslint-disable-next-line no-unused-vars
    // _draftValid(draftForm) {
    //   return true
    // },
    // /**
    //  * 草稿表单保存，需继承
    //  * @private
    //  */
    // // eslint-disable-next-line no-unused-vars
    // _draftPost(draftForm) {
    //   return Promise.resolve()
    // },

    /**
     * 处理全部最终提交数据，如有需要可继承
     * @param form
     * @private
     */
    _parseSubmitData: function _parseSubmitData(form) {
      return form;
    },
    // /**
    //  * 处理图片数据，当被拒绝只需要更新图片时需继承
    //  * @param form
    //  * @private
    //  */
    // _parseSubmitPhotoData(form) {
    //   return form
    // },
    // /**
    //  * 初始化oss
    //  * @private
    //  */
    // // eslint-disable-next-line no-unused-vars
    // _initOss(id) {
    //   // 如果当前tab比需要展示图片的tab大则初始化oss
    //   if (this.currentTab >= this.showPhotoIndex) {
    //     // this.asyncOssMerchantIdForRegister(id)
    //   }
    // },
    // /**
    //  * 渲染页面的头部
    //  * @returns {JSX.Element}
    //  * @private
    //  */
    // _renderPageHeader() {
    //   return (
    //     <e-page-header title={this.pageTitle} sub-title={this.pageSubTitle}>
    //       <div slot="content" class="page-header-content">
    //         <div>{this.pageDesc}</div>
    //         {this.reason ? <div class="reason">失败原因：{this.reason}</div> : null}
    //       </div>
    //       {this.showDraft && this.currentTab <= this.totalStepNum ? (
    //         <a-button slot="action" type="primary" ghost loading={this.draftLoading} onClick={this._saveDraft}>
    //           存为草稿
    //         </a-button>
    //       ) : null}
    //     </e-page-header>
    //   )
    // },

    /**
     *
     * 渲染步骤UI
     *
     */
    _renderStepComponents: function _renderStepComponents(h) {
      var _this5 = this;

      return this.stepList.map(function (item, index) {
        if (_this5.showedList.includes(index)) {
          return h(item, {
            ref: 'addStep' + index,
            key: index,
            "class": ['base-step-form'],
            props: {
              index: index,
              labelSpan: 8,
              formData: _this5.stepData,
              nextText: index === _this5.totalStepNum ? '保存' : null,
              nextLoading: index === _this5.totalStepNum ? _this5.saveLoading : false,
              isOnlyUpdatePhoto: _this5.isOnlyUpdatePhoto
            },
            on: {
              previewStep: _this5._previewStep,
              nextStep: _this5._nextStep,
              change: _this5._formValueChange
            },
            style: {
              display: _this5.currentTab === index ? undefined : 'none'
            }
          });
        }
      });
    },

    /**
     *
     * 渲染整个表单，包括最后一步结果
     *
     */
    _renderComponent: function _renderComponent(h) {
      return h('div', {}, [].concat(_toConsumableArray(this._renderStepComponents(h)), [h(this.resultComponentName, {
        props: {
          formData: this.stepData
        },
        style: {
          display: this.showResult ? undefined : 'none'
        },
        on: {
          goBack: this._goBack,
          resetToAdd: this._resetToEmpty
        }
      })]));
    },

    /**
     * 渲染自定义头部，需覆盖
     *
     */
    // eslint-disable-next-line no-unused-vars
    _customHeaderRender: function _customHeaderRender(h) {
      // return this.$createElement(ESaveDraftPageHeader)
      return null;
    }
  },
  render: function render(h) {
    return h("div", [this._customHeaderRender(h), h(_card["default"], {
      attrs: {
        bordered: false
      }
    }, [h(_steps["default"], {
      "class": "steps",
      attrs: {
        current: this.currentTab
      }
    }, [this.stepTextList.map(function (item) {
      return h(AStep, {
        attrs: {
          title: item
        }
      });
    })]), h("div", {
      "class": "content"
    }, [this.showLoading ? h(_Loading["default"], {
      style: "height:200px;"
    }) : this._renderComponent(h)])])]);
  }
};
exports["default"] = _default;