"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _PageHeader = _interopRequireDefault(require("../../../PageHeader"));

var _button = _interopRequireDefault(require("ant-design-vue/es/button"));

var _types = require("./types");

require("./style.less");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/**
 * 具有保存草稿功能的分布表单页面头,需要用 createElement(ESaveDraftPageHeader)方式传入
 */
var _default = {
  name: 'ESaveDraftPageHeader',
  props: _types.SaveDraftPageHeaderProps,
  render: function render() {
    var h = arguments[0];
    var _this$$props = this.$props,
        pageTitle = _this$$props.pageTitle,
        pageSubTitle = _this$$props.pageSubTitle,
        pageDesc = _this$$props.pageDesc,
        draftLoading = _this$$props.draftLoading,
        reason = _this$$props.reason,
        saveDraft = _this$$props.saveDraft;
    return h(_PageHeader["default"], {
      attrs: {
        title: pageTitle,
        "sub-title": pageSubTitle
      }
    }, [h("div", {
      slot: "content",
      "class": "page-header-content"
    }, [h("div", [pageDesc]), reason ? h("div", {
      "class": "reason"
    }, ["\u5931\u8D25\u539F\u56E0\uFF1A".concat(this.reason)]) : null]), h(_button["default"], {
      slot: "action",
      attrs: {
        type: "primary",
        ghost: true,
        loading: draftLoading
      },
      on: {
        "click": saveDraft
      }
    }, ["\u5B58\u4E3A\u8349\u7A3F"])]);
  }
};
exports["default"] = _default;